<template>
  <div class="row mt-3">
    <div class="col-10"></div>
    <div class="col text-end p-0">
      <button type="button" title="Borrar" alt="Borrar" @click="borrar()" class="btn btn-borrar  mx-2 text-uppercase p-0 px-2 fs-5"
        v-show="!esAlta">
        <i class="fa-solid fa-trash-can"></i>
      </button>
      <button alt="Guardar" title="Guardar" type="button" class="btn btn-guardar mx-2 fs-3" @click="guardar()">
        <i class="fa-solid fa-floppy-disk "></i>
      </button>
    </div>
  </div>
  <div class="d-md-flex align-items-center flex-wrap  p-4 contenedorPrincipal mt-3">
    <div class="col-3 ms-3">
      <label for="usuario" class="form-label">Usuario:</label>
      <auto-complete class="w-100" v-model="data.usuario" :elements="usuarioStore.listadoUsuarios" placeholder="Usuario"
        :minLength="3" :disabled="!esAlta" :initKey="data.usuarioHabilitado?.id_usuario" />
    </div>

    <div class="col-3 ms-3 ">
      <label for="apynom" class="form-label">Apellido y Nombre:</label>
      <input readonly type="text" :value="data.usuario?.ayn_usuario" class="form-control" id="apynom-solcitante" />
    </div>

    <div class="col-1 ms-3">
      <label for="tipo" class="form-label">Tipo:</label>
      <input readonly type="text" :value="data.usuario?.tipo_doc" class="form-control" id="tipo-solicitante" />
    </div>

    <div class="col-3 ms-3">
      <label for="doc" class="form-label">N° de Documento:</label>
      <input readonly type="text" :value="data.usuario?.nro_doc" class="form-control" id="doc-solicitante" />
    </div>

    <div class="col-4 ms-3 mt-3">
      <label for="dependencia" class="form-label">Dependencia:</label>
      <input readonly type="text" :value="data.usuario?.d_dependen_N" class="form-control" id="dependencia-solicitante" />
    </div>

    <div class="col-4 ms-3 mt-3">
      <label for="actualiza" class="form-label">Perfil Actualiza:</label>
      <select class="form-select" v-model="data.perfilactualiza">
        <option v-for="elemento in usuarioStore.listadoPerfilActualiza" :value="elemento.id_perfil">
          {{ elemento.perfil }}
        </option>
      </select>
    </div>

    <div class="col-3 ms-3 mt-3">
      <label for="consulta" class="form-label">Consulta todo:</label>
      <input type="checkbox" value="" v-model="data.consulta" class="form-check-input mt-3 ms-1 p-2"
        id="consulta-solicitante" />
    </div>

    <div class="d-flex justify-content-start mt-3">
      <div class="mx-1">
        <!-- Button trigger modal solicitante -->
        <button v-show="!enableComponent" type="button" class="btn btn-secondary mt-4 p-1 px-2 mb-4"
          @click="showModalSolicitante">
          <i></i> Por Solicitante
        </button>

        <Modal :verticalCentered="true" ref="modalSolicitante" :title="'PERMISOS POR SOLICITANTE'">

          <SolicitanteModal @close-modal="hideModalSolicitante"></SolicitanteModal>
        </Modal>
        <!--Fin Modal Solicitante -->
      </div>
      <div class="mx-1">
        <!-- Button trigger modal bloque -->
        <button v-show="!enableComponent" type="button" class="btn btn-secondary mt-4 p-1 px-2 mb-4"
          @click="showModalBloques">
          <i></i> Por Bloque
        </button>

        <!-- Modal Bloque -->
        <Modal :verticalCentered="true" ref="modalBloques" :title="'PERMISOS POR BLOQUE'">

          <BloqueModel @close-modal="hideModalBloques"></BloqueModel>

        </Modal>
        <!--Fin Modal Bloque -->
      </div>
    </div>
    <div class="col-12" v-show="!enableComponent">
      <ListadoSolicitantes></ListadoSolicitantes>
    </div>

  </div>
</template>

<script setup lang="ts">
//librerias
import { reactive, computed, ref, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import http from "@/http";
import { loading, urlApi, isEmpty } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, } from "sweetalert2";
//import { AxiosError } from "axios";
import { type AxiosResponse, AxiosError } from "axios";
import {
  AutoComplete,
  Modal,
} from "@hcd-bsas/vue3-components";
//Entities
import type { Usuariohabilitado } from "@/entities/Usuariohabilitado";
import type Usuario from "@/entities/Usuario";
// Stores
import { useUsuariosStore } from "@/stores/usuarios";
//component
import ListadoSolicitantes from "@/components/Usuarios/ListadoSolicitantes.vue";
import SolicitanteModal from "@/components/Usuarios/SolicitanteModal.vue";
import BloqueModel from "@/components/Usuarios/BloqueModal.vue";


const usuarioStore = useUsuariosStore();
const router = useRouter();
const route = useRoute();

const modalSolicitante = ref<typeof Modal>();
const modalBloques = ref<typeof Modal>();

const data = reactive({
  usuarioHabilitado: {} as Usuariohabilitado | null,
  perfilactualiza: 1 as number | null,
  usuario: null as Usuario | null,

  consulta: false as boolean,
  //isLoading: true,

});

const esAlta = computed(() => {
  return isEmpty(route.params.id) ? true : false;
});

const enableComponent = computed(() => {
  if (
    data.perfilactualiza == 3 &&
    data.perfilactualiza == data.usuarioHabilitado?.id_perfil
  ) {
    return false;
  } else {
    return true;
  }
});

onMounted(async () => {
  loading.show();

  usuarioStore.updateListadoUsuarios(import.meta.env.VITE_ID_APP);
  usuarioStore.updateListadoBloques();
  usuarioStore.updateListadoSolicitantes();
  await usuarioStore.updateListadoPerfilActualiza({
    perfil_actualiza: 1,
  });
  if (!esAlta.value) {
    await loadUsuario(Number(route.params.id));
  } else { loading.hide(); }

});

function showModalSolicitante() {
  modalSolicitante.value!.show();
}
function hideModalSolicitante() {
  modalSolicitante.value!.hide();
}

function showModalBloques() {
  modalBloques.value!.show();
}
function hideModalBloques() {
  modalBloques.value!.hide();
}

async function loadUsuario(id_usuario: number) {
  //loading.show();
  data.usuarioHabilitado = await usuarioStore.findUsuarioById(id_usuario, true);

  data.perfilactualiza = data.usuarioHabilitado!.id_perfil;
  data.consulta =
    data.usuarioHabilitado!.id_perfil_consulta == 2 ? true : false;
  loading.hide();
}

async function guardar() {

  const swal_error: SweetAlertOptions<any, any> = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!esAlta.value) {
    console.log("Con ID");
    loading.show();
    try {
      var rta = await http.post(urlApi + "modificarUsuarioPerfil", {
        id_usuario_perfil: data.usuarioHabilitado!.id_usuario_perfil,
        id_perfil: data.perfilactualiza,
        id_perfil_consulta: data.consulta == true ? 2 : data.perfilactualiza,
      });

      if (rta.data.status == "success") {
        Swal.fire({
          icon: "success",
          text: "Se modificaron los datos del Usuario.",
        }).then(async () => {
          //acatualizar la lista con true
          data.usuarioHabilitado = await usuarioStore.findUsuarioById(
            data.usuarioHabilitado!.id_usuario_perfil,
            true
          );
          await usuarioStore.updateListadoUsuariosSolicitantes({
            id_usuario_perfil: data.usuarioHabilitado?.id_usuario_perfil,
          });
          data.perfilactualiza = data.usuarioHabilitado!.id_perfil;
        });
        loading.hide();
        if (data.perfilactualiza == 3) {
          if (data.usuarioHabilitado?.id_perfil == data.perfilactualiza) {
            router.push({
              name: "inicioUsuarios",
            });
          }
        } else {
          router.push({
            name: "inicioUsuarios",
          });
        }
      } else {
        Swal.fire({
          icon: "error",
          text: rta.data.message,
        });
        loading.hide();
      }
    } catch (error: any) {
      var mensaje: string = error.message;

      if (error instanceof AxiosError) {
        mensaje = error.response?.data.res.mensaje;
      }
      Swal.fire({
        icon: "error",
        text: mensaje,
      });
    }
  } else {
    console.log("SIN ID");
    loading.show();
    await http
      .request<any>({
        method: "POST",
        url: urlApi + "addUsuarioPerfil",
        data: {
          id_usuario: data.usuario?.id_usuario,
          id_perfil: data.perfilactualiza,
          id_perfil_consulta: data.consulta == true ? 2 : data.perfilactualiza,
        },
      })
      .then(function (response: AxiosResponse<any, any>) {
        Swal.fire({
          icon: "success",
          text: "Se crea el Usuario.",
        }).then(async () => {
          data.usuarioHabilitado = await usuarioStore.findUsuarioByIdUsuario(
            data.usuario!.id_usuario,
            true
          );

          if (data.usuarioHabilitado?.id_perfil == 3) {
              router.push({
                name: "editar-usuarios",params:{id:data.usuarioHabilitado?.id_usuario_perfil}
              });
          } else {
            router.push({
              name: "inicioUsuarios",
            });
          }
        });
        loading.hide();
      })
      .catch(function (error: AxiosError<string, any>) {
        if (error.response) {
          // Request made and server responded
          swal_error.html =
            error.message +
            " (" +
            error.code +
            ")." +
            "<br />" +
            error.response.data.substring(
              error.response.data.indexOf("<h2>") + 4,
              error.response.data.indexOf("</h2>")
            );
          console.log("Error: request made and server responded");
          console.log(swal_error.html);
          console.log(error.response);
        } else if (error.request) {
          // The request was made but no response was received
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log(
            "Error: the request was made but no response was received"
          );
          console.log(error.request);
        } else {
          // Something happened in setting up the request that triggered an Error
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log(
            "Error: something happened in setting up the request that triggered an error"
          );
          console.log(error);
        }
        loading.hide();
        Swal.fire(swal_error);
      });
  }
}

async function borrar() {
  Swal.fire({
    icon: "question",
    title: "Confirmaci&oacute;n",
    html: "¿Confirma la eliminaci&oacute;n del Usuario? Esta acci&oacute;n no podr&aacute; ser revertida.",
    showCancelButton: true,
    confirmButtonColor: "#3085d6",
    cancelButtonColor: "#d33",
    confirmButtonText: "Confirmar",
    cancelButtonText: "Cancelar",
  }).then(async (result) => {
    if (result.isConfirmed) {
      loading.show();
      try {
        var rta = await http.post(urlApi + "borrarUsuarioPerfil", {
          id_usuario_perfil: data.usuarioHabilitado!.id_usuario_perfil,
        });
        if (rta.data.status == "success") {
          Swal.fire({
            icon: "success",
            text: "Se borro el Usuario.",
          }).then(() => {
            router.push({ name: "inicioUsuarios" });
          });
          loading.hide();
        } else {
          Swal.fire({
            icon: "error",
            text: rta.data.message,
          });
          loading.hide();
        }
      } catch (error: any) {
        var mensaje: string = error.message;

        if (error instanceof AxiosError) {
          mensaje = error.response?.data.res.mensaje;
        }
        Swal.fire({
          icon: "error",
          text: mensaje,
        });
      }
    }
  });
}
</script>
